const oar = @import("oar");
const ona = @import("ona");
const std = @import("std");

file_access: ona.io.FileAccess,
index_cache: IndexCache,
entry_table: [max_open_entries]Entry = std.mem.zeroes([max_open_entries]Entry),

///
/// Hard limit on the maximum number of entries open at once.
///
const max_open_entries = 16;

///
/// Stateful extension of an [oar.Entry].
///
pub const Entry = struct {
    owner: ?*ona.io.FileAccess,
    cursor: u64,
    header: oar.Entry,
};

///
/// Table cache for associating [oar.Path] values with offsets to entries in a given file.
///
pub const IndexCache = ona.table.Hashed(oar.Path, u64, .{
    .equals = oar.Path.equals,
    .hash = oar.Path.hash,
});
